--- syslog-r23119-with-HT-enabled.txt	Thu Dec 13 15:02:37 2007
+++ syslog-r23119-without-HT-enabled.txt	Thu Dec 13 15:14:08 2007
@@ -9,20 +9,13 @@
 KERN: smp: skipping uninteresting header 'FACP'
 KERN: smp: local apic address is 0xfee00000
 KERN: smp: found local APIC with id 0
-KERN: smp: found local APIC with id 1
+KERN: smp: found local APIC with id 129
+KERN: smp: APIC is disabled and will not be used
 KERN: smp: found local APIC with id 130
 KERN: smp: APIC is disabled and will not be used
 KERN: smp: found local APIC with id 131
 KERN: smp: APIC is disabled and will not be used
-KERN: smp: found io APIC with id 2 and address 0xfec00000
-KERN: smp_boot: had found > 1 cpus
-KERN: post config:
-KERN: num_cpus = 2
-KERN: apic_phys = 0xfee00000
-KERN: ioapic_phys = 0xfec00000
-KERN: apic = 0x80108000
-KERN: ioapic = 0x80109000
-KERN: APIC ticks/sec = 199629558
+KERN: smp: found io APIC with id 1 and address 0xfec00000
 KERN: VESA version = 3.0
 KERN: oem string: Intel(r)865G Graphics Chip Accelerated VGA BIOS
 KERN:   160: 0 x 0 x 0 (a = 0, mem = 0, phy = 0, p = 0, b = 0)
@@ -101,15 +94,16 @@
 KERN: Welcome to the Haiku boot loader!
 KERN: ATA device, master
 KERN: number of drives: 1
-KERN: add_partitions_for(0x001091c0, mountFS = no)
+KERN: add_partitions_for(0x001051c0, mountFS = no)
 KERN: add_partitions_for(fd = 0, mountFS = no)
 KERN: Partition::Scan()
 KERN: check for partitioning_system: Amiga Partition Map
 KERN: check for partitioning_system: EFI GUID Partition Map
 KERN: check for partitioning_system: Intel Partition Map
-KERN: intel: pm_identify_partition(1, 1086228: 0, 82348277760, 512)
+KERN: intel: pm_identify_partition(1, 1069844: 0, 82348277760, 512)
 KERN: Partition::SetTo(): active: 80
 KERN: Partition::SetTo(): active: 0
+Last message repeated 4 times
 KERN: INIT: init system info
 KERN: INIT: init SMP
 KERN: INIT: init timer
@@ -133,16 +127,11 @@
 KERN: INIT: init notification services
 KERN: INIT: init VFS
 KERN: INIT: waking up AP cpus
-KERN: CPU 1: type 0 family 15 model 4 stepping 9, string 'GenuineIntel'
-KERN: CPU 1: vendor 'Intel' model name 'Intel(R) Pentium(R) 4 CPU 3.00GHz'
-KERN: CPU 1: features: fpu vme de pse tsc msr pae mce cx8 apic sep mtrr pge mca cmov pat pse36 clfsh ds acpi mmx fxsr sse sse2 ss htt tm pbe sse3 monitor dscpl cnxtid 
 KERN: INIT: exiting kernel startup
 KERN: INIT: enabling interrupts and starting scheduler on cpu 0
-KERN: INIT: main: done... begin idle loop on cpu 1
 KERN: INIT: starting main2 thread
 KERN: INIT: resuming main2 thread...
 KERN: INIT: start of main2: initializing devices
-KERN: INIT: main: done... begin idle loop on cpu 0
 KERN: INIT: Init modules
 KERN: INIT: Init Userland debugging
 KERN: INIT: Init Messaging Service
@@ -198,7 +187,7 @@
 KERN: PCI: DiscoverDevice, domain 0, bus 1, dev 0, func 1
 KERN: PCI: CreateDevice, domain 0, bus 1, dev 0, func 1:
 KERN: PCI: vendor 0x109e, device 0x0878, class_base 0x04, class_sub 0x80
-KERN: PCI: DiscoverDevice, domain 0, bus 1, de<DROP>KERN: nc 2
+KERN: PCI: DiscoverDevice, domain 0, bus 1, dev 0, func 2
 KERN: PCI: DiscoverDevice, domain 0, bus 1, dev 0, func 3
 KERN: PCI: DiscoverDevice, domain 0, bus 1, dev 0, func 4
 KERN: PCI: DiscoverDevice, domain 0, bus 1, dev 0, func 5
@@ -206,7 +195,7 @@
 KERN: PCI: DiscoverDevice, domain 0, bus 1, dev 0, func 7
 KERN: PCI: DiscoverDevice, domain 0, bus 1, dev 5, func 0
 KERN: PCI: CreateDevice, domain 0, bus 1, dev 5, func 0:
-KERN: PCI: vendor 0x10ec, device 0x8139, class_base 0x02, class_sub 0x00
+KERN: PCI: vendor 0x1<DROP>KERN: vice 0x8139, class_base 0x02, class_sub 0x00
 KERN: PCI: DiscoverDevice, domain 0, bus 0, dev 31, func 0
 KERN: PCI: CreateDevice, domain 0, bus 0, dev 31, func 0:
 KERN: PCI: vendor 0x8086, device 0x24d0, class_base 0x06, class_sub 0x01
@@ -328,13 +317,13 @@
 KERN: PCI:   ROM base host 00000000, pci 00000000, size 00000000
 KERN: PCI:   cardbus_CIS 00000000, subsystem_id 24d0, subsystem_vendor_id 1849
 KERN: PCI:   interrupt_line 0b, interrupt_pin 04, min_grant 00, max_latency 00
-KERN: PCI:   base reg 0: host ff27fc00, pci ff27fc00KERN: , size 00000400, flags 00
+KERN: PCI:   base reg 0: host ff27fc00, pci ff27fc00, size 00000400, flags 00
 KERN: PCI:   base reg 1: host 00000000, pci 00000000, size 00000000, flags 00
 KERN: PCI:   base reg 2: host 00000000, pci 00000000, size 00000000, flags 00
 KERN: PCI:   base reg 3: host 00000000, pci 00000000, size 00000000, flags 00
 KERN: PCI:   base reg 4: host 00000000, pci 00000000, size 00000000, flags 00
 KERN: PCI:   base reg 5: host 00000000, pci 00000000, size 00000000, flags 00
-KERN: PCI:   Capabilities: PM, DebugPort
+KERN: PCI:KERN:    Capabilities: PM, DebugPort
 KERN: PCI: [dom 0, bus  0] bus   0, device 30, function  0: vendor 8086, device 244e, revision c2
 KERN: PCI:   class_base 06, class_function 04, class_api 00
 KERN: PCI:   vendor 8086: Intel Corporation
@@ -458,13 +447,13 @@
 KERN: PCI:   line_size 00, latency 00, header_type 00, BIST 00
 KERN: PCI:   ROM base host 00000000, pci 00000000, size 00000000
 KERN: PCI:   cardbus_CIS 00000000, subsystem_id 9761, subsystem_vendor_id 1849
-KERN: PCI:   interrupt_line 0b, interrupt_pin 02, minKERN: _grant 00, max_latency 00
+KERN: PCI:   interrupt_line 0b, interrupt_pin 02, min_grant 00, max_latency 00
 KERN: PCI:   base reg 0: host 0000d800, pci 0000d800, size 00000100, flags 01
 KERN: PCI:   base reg 1: host 0000d400, pci 0000d400, size 00000040, flags 01
 KERN: PCI:   base reg 2: host ff27f800, pci ff27f800, size 00000200, flags 00
 KERN: PCI:   base reg 3: host ff27f400, pci ff27f400, size 00000100, flags 00
 KERN: PCI:   base reg 4: host 00000000, pci 00000000, size 00000000, flags 00
-KERN: PCI:   base reg 5: host 00000000, pci 00000000, size 00000000, flags 00
+KERN: PCI:KERN:    base reg 5: host 00000000, pci 00000000, size 00000000, flags 00
 KERN: PCI:   Capabilities: PM
 KERN: 	found root!!
 KERN: 	add module bus_managers/pci/root/device_v1 to list
@@ -487,7 +476,7 @@
 KERN: field: "boot drive number", type: LLNG (0x4c4c4e47):
 KERN:   [ 0] 128 (0x80)
 KERN: field: "disk identifier", type: RAWT (0x52415754):
-KERN:   [ 0] data: "0x803fb928", 80 bytes
+KERN:   [ 0] data: "0x803f5928", 80 bytes
 KERN: get_boot_partitions(): boot method type: 0
 KERN: partitioning system: partitioning_systems/intel/extended/v1
 KERN: KDiskDeviceManager::_AddDiskSystem(partitioning_systems/intel/extended/v1)
@@ -590,6 +579,7 @@
 KERN: module: busses/ide/legacy_sata/device_v1, support: 0
 KERN: module: busses/ide/silicon_image_3112/device_v1, support: 0
 KERN: module: busses/ide/generic_ide_pci/device_v1, support: 0.3
+KERN: INIT: main: done... begin idle loop on cpu 0
 KERN: 	found scsi!!
 KERN: 	add module drivers/disk/scsi/scsi_dsk/device_v1 to list
 KERN: [35mahci:[0m ahci_get_supported_paths
@@ -656,7 +646,7 @@
 KERN: 	add module busses/ide/legacy_sata/device_v1 to list
 KERN: 	found pci!!
 KERN: 	found drivers/dev/disk/sata!!
-KERN: 	add module bussesKERN: /ide/silicon_image_3112/device_v1 to list
+KERN: 	add module busses/ide/silicon_image_3112/device_v1 to list
 KERN: 	found pci!!
 KERN: 	found drivers/dev/disk/ide!!
 KERN: 	add module busses/ide/generic_ide_pci/device_v1 to list
@@ -664,7 +654,7 @@
 KERN: [35mahci:[0m ahci_supports_device
 KERN: module: busses/scsi/ahci/device_v1, support: 0
 KERN: module: busses/ide/legacy_sata/device_v1, support: 0
-KERN: module: busses/ide/silicon_image_3112/device_v1, support: 0
+KERN: module: busses/ide/silicon_image_3112/device_v1KERN: , support: 0
 KERN: module: busses/ide/generic_ide_pci/device_v1, support: 0
 KERN: free busses/scsi/ahci/device_v1
 KERN: free busses/ide/legacy_sata/device_v1
@@ -872,7 +862,7 @@
 KERN: module: busses/scsi/ahci/device_v1, support: 0
 KERN: module: busses/ide/legacy_sata/device_v1, support: 0
 KERN: module: busses/ide/silicon_image_3112/device_v1, support: 0
-KERN: module: busses/ide/generic_iKERN: de_pci/device_v1, support: 0
+KERN: module: busses/ide/generic_ide_pci/device_v1, support: 0
 KERN: free busses/scsi/ahci/device_v1
 KERN: free busses/ide/legacy_sata/device_v1
 KERN: free busses/ide/silicon_image_3112/device_v1
@@ -882,7 +872,7 @@
 KERN: 	found drivers/dev/disk/sata!!
 KERN: 	add module busses/scsi/ahci/device_v1 to list
 KERN: 	found pci!!
-KERN: 	found drivers/dev/disk/sata!!
+KERN: 	found drivers/KERN: dev/disk/sata!!
 KERN: 	add module busses/ide/legacy_sata/device_v1 to list
 KERN: 	found pci!!
 KERN: 	found drivers/dev/disk/sata!!
@@ -1074,14 +1064,14 @@
 KERN: KDiskSystem::Unload(): file_systems/devfs/v1 -> 0
 KERN: KDiskSystem::Load(): file_systems/rootfs/v1 -> 1
 KERN:   trying: file_systems/rootfs/v1
-KERN:   returnKERN: ed: -1000/1000
+KERN:   returned: -1000/1000
 KERN: KDiskSystem::Unload(): file_systems/rootfs/v1 -> 0
 KERN:   scanning with: file_systems/bfs/v1
 KERN: KDiskSystem::Load(): file_systems/bfs/v1 -> 2
 KERN: KDiskSystem::Unload(): file_systems/bfs/v1 -> 1
 KERN: KDiskDeviceManager::_ScanPartition(/dev/disk/ata/0/master/1_1)
 KERN: KDiskSystem::Load(): partitioning_systems/intel/extended/v1 -> 3
-KERN:   trying: partitioning_systems/intel/extended/v1
+KERN:   trying: partitioniKERN: ng_systems/intel/extended/v1
 KERN: intel: ep_identify_partition(0, 10742247936, 5371075584, 512)
 KERN:   returned: -1000/1000
 KERN: KDiskSystem::Unload(): partitioning_systems/intel/extended/v1 -> 2
@@ -1257,13 +1247,13 @@
 KERN: KDiskSystem::Unload(): file_systems/rootfs/v1 -> 0
 KERN: KDiskDeviceManager::_ScanPartition(/dev/disk/ata/0/master/1_6)
 KERN: KDiskSystem::Load(): partitioning_systems/intel/extended/v1 -> 3
-KERN:   trying: partitiKERN: oning_systems/intel/extended/v1
+KERN:   trying: partitioning_systems/intel/extended/v1
 KERN: intel: ep_identify_partition(0, 42606982656, 5395751424, 512)
 KERN:   returned: -1000/1000
 KERN: KDiskSystem::Unload(): partitioning_systems/intel/extended/v1 -> 2
 KERN: KDiskSystem::Load(): partitioning_systems/intel/map/v1 -> 3
 KERN:   trying: partitioning_systems/intel/map/v1
-KERN: intel: pm_identify_partition(0, 11: 42606982656, 5395751424, 512)
+KERN: intel: pm_identify_partition(0, 11: 42606982656, 53957514KERN: 24, 512)
 KERN: intel: _ParsePrimary(): invalid PTS signature
 KERN:   returned: -1000/1000
 KERN: KDiskSystem::Unload(): partitioning_systems/intel/map/v1 -> 2
@@ -1438,7 +1428,7 @@
 KERN:   returned: -1000/1000
 KERN: KDiskSystem::Unload(): partitioning_systems/intel/extended/v1 -> 2
 KERN: KDiskSystem::Load(): partitioning_systems/intel/map/v1 -> 5
-KERN:   trying: partitioning_systems/intel/mKERN: ap/v1
+KERN:   trying: partitioning_systems/intel/map/v1
 KERN: intel: pm_identify_partition(0, 17: 76297729536, 238500864, 512)
 KERN: intel: _ParsePrimary(): invalid PTS signature
 KERN:   returned: -1000/1000
@@ -1446,10 +1436,19 @@
 KERN: KDiskSystem::Load(): file_systems/pipefs/v1 -> 1
 KERN:   trying: file_systems/pipefs/v1
 KERN:   returned: -1000/1000
-KERN: KDiskSystem::Unload(): file_systems/pipefs/v1 -> 0
-KERN: KDiskSystem::Load(<TRUNC> /dev/net/rtl8139/0: media change, media 0x900026 quality 1000 speed 10000
-KERN: ps2_hid: init_hardware
+KERN: KDiskSystem::Unload(): file_systems/piKERN: pefs/v1 -> 0
+KERN: KDiskSystem::Load(): file_systems/bfs/v1 -> 6
+KERN:   trying: file_systems/bfs/v1
+KERN:   returned: -2147483648/1000
+KERN: KDiskSystem::Unload(): file_systems/bfs/v1 -> 5
+KERN: KDiskSystem::Load(): file_systems/devfs/v1 -> 1
+KERN:   trying: file_systems/devfs/v1
+KERN:   returned: -1000/1000
+KERN: KDiskSystem::Unload(): file_systems/devfs/v1 -> 0
+KERN: KDiskSystem::Load(): file_systems/rootfs/v1 -> 1
+KERN:   trying<TRUNC> ps2_hid: init_hardware
 KERN: ps2_hid: init_driver
+KERN: /dev/net/rtl8139/0: media change, media 0x900026 quality 1000 speed 10000
 KERN: ps2_hid: publish_devices
 KERN: ps2_hid: publish_devices() returned NULL.
 KERN: ps2_hid: uninit_driver
@@ -1463,7 +1462,7 @@
 KERN: cx23882: init_hardware() failed: General system error
 KERN: auich: init_hardware()
 KERN: auich: init_driver()
-KERN: auich: auich_setup(0x93f457c0)
+KERN: auich: auich_setup(0x93f377c0)
 KERN: auich: audio/hmulti/auich/1 deviceid = 0x24d5 chiprev = 2 model = 9761 enhanced at d800
 KERN: auich: PCI command before: 7
 KERN: auich: PCI command after: 7
@@ -1503,8 +1502,8 @@
 KERN: auich: name : Center/Lfe
 KERN: auich: name : Recording
 KERN: auich: multi->control_count 46
-KERN: firewire: fw_module_init
 KERN: ps2: probe_mouse Extended PS/2 mouse found
+KERN: firewire: fw_module_init
 KERN: firewire: found 0 cards
 KERN: firewire: fw_module_uninit
 KERN: fw_raw: init_driver() failed: No such device